Package: readBrukerFlexData
Version: 1.9.3
Date: 2024-10-02
Title: Reads Mass Spectrometry Data in Bruker *flex Format
Authors@R: 
    c(
        person(
            "Sebastian", "Gibb", role = c("aut", "cre"),
            email = "mail@sebastiangibb.de",
            comment = c(ORCID = "0000-0001-7406-4443")
        ),
        person("Samuel", "Granjeaud", role = "ctb"),
        person("Alan", "Race", role = "ctb",
            email = "alan.race@uni-marburg.de",
            comment = c(ORCID = "0000-0001-8996-2641")
        )
    )
Depends: R (>= 3.3.0)
Suggests: testthat
Description: Reads data files acquired by Bruker Daltonics' matrix-assisted
    laser desorption/ionization-time-of-flight mass spectrometer of the *flex
    series.
License: GPL (>= 3)
URL: https://strimmerlab.github.io/software/maldiquant/,
        https://github.com/sgibb/readBrukerFlexData/
BugReports: https://github.com/sgibb/readBrukerFlexData/issues/
LazyLoad: yes
RoxygenNote: 7.3.1
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2024-10-02 21:01:19 UTC; sebastian
Author: Sebastian Gibb [aut, cre] (<https://orcid.org/0000-0001-7406-4443>),
  Samuel Granjeaud [ctb],
  Alan Race [ctb] (<https://orcid.org/0000-0001-8996-2641>)
Maintainer: Sebastian Gibb <mail@sebastiangibb.de>
Repository: CRAN
Date/Publication: 2024-10-02 21:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 21:32:22 UTC; unix

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Mass spectrum generated by Bruker Daltonics CompassXport
#'
#' This dataset was generated by Bruker Daltonics CompassXport and imported by
#' \code{\link[readMzXmlData]{readMzXmlFile}} to R. It is only needed for
#' comparison between Bruker Daltonics' HPC and
#' \code{\link[readBrukerFlexData]{.hpc}}.
#'
#' @format A list containing a mass and an intensity vector.
#' @source Examples/hpc/mzXML/hpc.mzXML
#' @seealso
#'  \code{\link[readBrukerFlexData]{.hpc}},
#'  \code{\link[readMzXmlData]{readMzXmlFile}}
#' @name cpSpecHpcMzXml
#' @rdname cpSpecHpcMzXml
#' @docType data
#' @keywords datasets
NULL

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Reads recursively mass spectrometry data in Bruker Daltonics XMASS format.
#'
#' This function leads recursively all mass spectrometry data in
#' Bruker Daltonics XMASS format in a specified directory.
#'
#' @details
#' See \code{\link[readBrukerFlexData]{readBrukerFlexFile}}.
#'
#' @param brukerFlexDir \code{character}, path to \emph{directory} which
#'  should be read recursively.
#' @param removeCalibrationScans \code{logical}, if \code{TRUE} all scans in
#'  directories called \code{[Cc]alibration} will be ignored.
#' @param removeMetaData \code{logical}, to calculate mass data a lot of
#'  meta data are needed. To save memory they could be deleted after
#'  calculation.
#' @param useHpc \code{logical}, should Bruker Daltonics' High Precision
#'  Calibration be used if available? (see also:
#'  \code{\link[readBrukerFlexData]{.hpc}})
#' @param useSpectraNames \code{logical}, if \code{TRUE} all list elements
#'  get an unique name from metaData otherwise file path is used.
#'  (If \sQuote{removeMetaData} is \code{TRUE} \sQuote{useSpectraNames}
#'  has no effect.)
#' @param filterZeroIntensities \code{logical}, don't change it. If \code{TRUE}
#'  all intensities equal \code{0.0} are removed.
#'  (see also: \code{\link[readBrukerFlexData]{readBrukerFlexFile}})
#' @param verbose \code{logical}, print verbose messages?
#'
#' @return
#' A \code{list} of spectra.
#' \itemize{
#'     \item{\code{[[1]]$spectrum$mass}: A vector of calculated mass.}
#'     \item{\code{[[1]]$spectrum$intensity}: A vector of intensity values.}
#'     \item{\code{[[1]]$metaData}: A list of metaData depending on read spectrum.}
#' }
#'
#' @export
#' @seealso
#'  \code{\link[MALDIquantForeign]{importBrukerFlex}},
#'  \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
#'  \code{\link[readBrukerFlexData]{.hpc}}
#' @rdname readBrukerFlexDir
#' @keywords IO
#' @examples
#' ## load library
#' library("readBrukerFlexData")
#'
#' ## get examples directory
#' exampleDirectory <- system.file("Examples", package="readBrukerFlexData")
#'
#' ## read example spectra
#' spec <- readBrukerFlexDir(file.path(exampleDirectory,
#'   "2010_05_19_Gibb_C8_A1"))
#'
#' ## plot spectra
#' plot(spec[[1]]$spectrum$mass, spec[[1]]$spectrum$intensity, type="n")
#'
#' l <- length(spec)
#' legendStr <- character(l)
#' for (i in seq(along=spec)) {
#'   lines(spec[[i]]$spectrum$mass, spec[[i]]$spectrum$intensity, type="l",
#'         col=rainbow(l)[i])
#'   legendStr[i] <- spec[[i]]$metaData$fullName
#' }
#'
#' ## draw legend
#' legend(x="topright", legend=legendStr, col=rainbow(l), lwd=1)
#'
readBrukerFlexDir <- function(brukerFlexDir, removeCalibrationScans=TRUE,
                              removeMetaData=FALSE, useHpc=TRUE,
                              useSpectraNames=TRUE,
                              filterZeroIntensities=FALSE, verbose=FALSE) {
  if (verbose) {
    message("Look for spectra in ", sQuote(brukerFlexDir), " ...")
  }

  if ((!file.exists(brukerFlexDir)) || (!file.info(brukerFlexDir)$isdir)) {
    stop("Directory ", sQuote(brukerFlexDir),
         " doesn't exists or is no directory!")
  }

  ## look for fid files (alphabetical sort)
  files <- list.files(path=brukerFlexDir, pattern="^fid$", recursive=TRUE)

  ## remove calibrations scans?
  if (removeCalibrationScans) {
    calibrationScans <- grep(pattern="[Cc]alibration", x=files, value=TRUE)
    if (length(calibrationScans)) {
      files <- setdiff(files, calibrationScans)
    }
  }

  if (length(files) <= 0) {
    stop("Directory doesn't contain any fid file.")
  }

  ## generate 'path/files'
  files <- file.path(brukerFlexDir, files)

  ## read fid files
  brukerFlexData <- lapply(X=files, FUN=function(f) {
    readBrukerFlexFile(fidFile=f, removeMetaData=removeMetaData,
                       useHpc=useHpc,
                       filterZeroIntensities=filterZeroIntensities,
                       verbose=verbose)
  })

  if (!removeMetaData & useSpectraNames) {
    ## rewrite names if metadata exists
    if (verbose) {
      message("look for spectra names ...")
    }

    names(brukerFlexData) <- sapply(X=brukerFlexData, FUN=function(x) {
      if (!is.null(x$metaData$sampleName)) {
        if (!is.na(x$metaData$sampleName)) {
          return(paste0("s", x$metaData$fullName, ".",
                        x$metaData$targetIdString))
        }
      }
      return(NA)
    }, USE.NAMES=FALSE)
  }

  brukerFlexData
}

## Copyright 2010-2013 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Reads mass spectrometry data in Bruker Daltonics XMASS format.
#'
#' This function reads mass spectrometry data in Bruker Daltonics XMASS format
#' used by Bruker Daltonics mass spectrometer of *flex series (autoflex,
#' microflex, ultraflex).
#'
#' @details
#' \code{readBrukerFlexFile} has to import the following data to calculating
#' mass from \emph{acqu} file:\cr
#'
#' \tabular{lll}{
#' acqu-value \tab becomes metaData \tab description \cr
#' $BYTORDA \tab metaData$byteOrder \tab endianness of fid file \cr
#' $TD \tab metaData$number \tab total number of measured time periods \cr
#' $DELAY \tab metaData$timeDelay \tab first measured intensity after
#'   \emph{metaData$timeDelay} ns \cr
#' $DW \tab metaData$timeDelta \tab ns between measured time periods \cr
#' $ML1 \tab metaData$calibrationConstants[1] \tab mass calibration constant \cr
#' $ML2 \tab metaData$calibrationConstants[2] \tab mass calibration constant \cr
#' $ML3 \tab metaData$calibrationConstants[3] \tab mass calibration constant \cr
#' }
#'
#' If High Precision Calibration (HPC) is used, \code{readBrukerFlexFile} needs:
#' \tabular{lll}{
#' acqu-value \tab becomes metaData \tab description \cr
#' $HPClBHi \tab metaData$hpc$limits[\dQuote{maxMass}] \tab upper mass
#'  threshold \cr
#' $HPClBLo \tab metaData$hpc$limits[\dQuote{minMass}] \tab lower mass
#'  threshold \cr
#' $HPClOrd \tab metaData$hpc$order \tab polynomial order \cr
#' $HPClUse \tab metaData$hpc$use \tab maybe using of HPC? (seems to be always
#' \dQuote{yes} in our test data) \cr
#' $HPCStr \tab metaData$hpc$coefficients \tab polynomial coefficients in a
#' string \cr
#' }
#'
#' \code{readBrukerFlexFile} tries also to import [optional]: \cr
#' \tabular{lll}{
#' acqu-value \tab becomes metaData \tab description \cr
#' DATATYPE \tab metaData$dataType \tab e.g CONTINUOUS MASS SPECTRUM \cr
#' SPECTROMETER/DATASYSTEM \tab metaData$dataSystem \tab
#'  e.g. Bruker Flex Series \cr
#' .SPECTROMETER TYPE \tab metaData$spectrometerType \tab e.g. TOF \cr
#' .INLET \tab metaData$inlet \tab DIRECT \cr
#' .IONIZATION MODE \tab metaData$ionizationMode \tab e.g. LD+ \cr
#' $DATE \tab metaData$date \tab same as $AQ_DATE but often only "0" \cr
#' $ACQMETH \tab metaData$acquisitionMethod \tab path to method file \cr
#' $AQ_DATE \tab metaData$acquisitionDate \tab acquisition date \cr
#' $AQ_mod \tab metaData$acquisitionMode \tab acquisition mode \cr
#' $AQOP_m \tab metaData$acquisitionOperatorMode, metaData$tofMode \tab
#'  LINEAR / REFLECTOR \cr
#' $ATTEN \tab metaData$laserAttenuation \tab laser beam attenuation \cr
#' $CMT[1:4] \tab metaData$comments \tab comments \cr
#' $DEFLON \tab metaData$deflection \tab deflection ON/OFF \cr
#' $DIGTYP \tab metaData$digitizerType \tab type of digitizer \cr
#' $DPCAL1 \tab metaData$deflectionPulserCal1 \tab deflection pulser cal 1 \cr
#' $DPMASS \tab metaData$deflectionPulserMass \tab deflection pulser mass \cr
#' $FCVer \tab metaData$flexControlVersion \tab Version of
#'  Bruker Daltonics FlexControl software \cr
#' $ID_raw \tab metaData$id \tab spectrum id \cr
#' $INSTRUM \tab metaData$instrument \tab e.g. AUTOFLEX \cr
#' $InstrID \tab metaData$instrumentId \tab ID of mass spectrometer \cr
#' $InstTyp \tab metaData$instrumentType \tab instrument type \cr
#' $Lift1 \tab metaData$lift[1] \tab LIFT constant? \cr
#' $Lift2 \tab metaData$lift[2] \tab LIFT constant? \cr
#' $Masserr \tab metaData$massError \tab initial mass error in ppm \cr
#' $NoSHOTS \tab metaData$laserShots \tab number of applied laser shots \cr
#' $PATCHNO \tab metaData$patch \tab sample postion on target \cr
#' $PATH \tab metaData$path \tab original file path
#'  (on Bruker *flex series controller PC) \cr
#' $REPHZ \tab metaData$laserRepetition \tab laser repetition rate in Hz \cr
#' $SPOTNO \tab metaData$spot \tab same as \emph{$PATCHNO}
#'  (in older files often empty, that's why \code{readBrukerFlexFile}
#'  uses \emph{$PATHNO} instead) \cr
#' $SPType \tab metaData$spectrumType \tab e.g. TOF \cr
#' $TgIDS \tab metaData$target$id \tab target ids \cr
#' $TgCount \tab metaData$target$count \tab number of measurements
#'  with this target \cr
#' $TgSer \tab metaData$target$serialNumber \tab target serial number \cr
#' $TgTyp \tab metaData$target$typeNumber \tab target type number \cr
#' $TLift \tab metaData$tlift \tab LIFT constant? \cr
#' }
#'
#' import from file path:
#' \tabular{lll}{
#' value \tab becomes metaData \tab description \cr
#' full current path to fid file \tab metaData$file \tab
#'  path on local machine \cr
#' sample name \tab metaData$sampleName \tab - \cr
#' }
#'
#' \code{filterZeroIntensities}: Change default value is \bold{not recommended}!
#' If \code{TRUE} all intensities equal zero are removed.
#' This parameter exists only to be compatible to
#' Bruker Daltonics CompassXport's mzXML export function. For details see:
#' \sQuote{Release Notes for CompassXport 3.0.3},
#' cap. 6 \sQuote{Filtering of Zero Intensities}:
#' \dQuote{Bruker Daltonics' Acquisition Software will compress Analysis raw
#' data. To save on operation time and to keep export file sizes small,
#' CompassXport 3.0.3 will filter out zero (0.0) intensities
#' when exporting to mzXML or mzData \ldots}
#'
#' \code{keepNegativeIntensities}: Change default value is
#' \bold{not recommended}! If \code{TRUE} negative intensity values are not
#' replaced by zero. This parameter exists only to be compatible to
#' Bruker Daltonics CompassXport.
#'
#'
#' @param fidFile \code{character}, path to \emph{fid} file which should be
#'  read.
#' @param removeMetaData, \code{logical}, to calculate mass data a lot of meta
#'  data are needed. To save memory they could be deleted after calculation.
#' @param useHpc \code{logical}, should Bruker Daltonics' High Precision
#'  Calibration be used if available?
#'  (see also: \code{\link[readBrukerFlexData]{.hpc}})
#' @param filterZeroIntensities \code{logical}, don't change it.
#'  If \code{TRUE} all intensities equal \code{0.0} are removed.
#'  (see also: \sQuote{Details} section)
#' @param keepNegativeIntensities \code{logical}, don't change it.
#'  If \code{FALSE} all intensities less than zero are replaced by
#'  zero.
#'  (see also: \sQuote{Details} section)
#' @param verbose \code{logical}, print verbose messages?
#'
#' @return
#'  A \code{list} of spectra and metadata.
#'
#'  \itemize{
#'     \item{\code{spectrum$mass}: A vector of calculated mass.}
#'     \item{\code{spectrum$tof}: A vector of time-of-flight data.}
#'     \item{\code{spectrum$intensity}: A vector of intensity values.}
#'     \item{\code{metaData}: A list of metaData depending on read spectrum.}
#' }
#' @export
#' @seealso
#'  \url{https://github.com/sgibb/readBrukerFlexData/wiki},
#'  \code{\link[MALDIquantForeign]{importBrukerFlex}},
#'  \code{\link[readBrukerFlexData]{readBrukerFlexDir}},
#'  \code{\link[readBrukerFlexData]{.hpc}}
#' @keywords IO
#' @rdname readBrukerFlexFile
#' @examples
#' ## load library
#' library("readBrukerFlexData")
#'
#' ## get examples directory
#' exampleDirectory <- system.file("Examples", package="readBrukerFlexData")
#'
#' ## read example spectrum
#' spec <- readBrukerFlexFile(file.path(exampleDirectory,
#'   "2010_05_19_Gibb_C8_A1/0_A1/1/1SLin/fid"))
#'
#' ## print metaData
#' print(spec$metaData)
#'
#' ## plot spectrum
#' plot(spec$spectrum$mass, spec$spectrum$intensity, type="l", col="red")
#'
readBrukerFlexFile <- function(fidFile, removeMetaData=FALSE, useHpc=TRUE,
                               filterZeroIntensities=FALSE,
                               keepNegativeIntensities=FALSE,
                               verbose=FALSE) {
  if (verbose) {
    message("Reading spectrum from ", sQuote(fidFile), " ...")
  }

  if (!file.exists(fidFile)) {
    stop("File ", sQuote(fidFile), " doesn't exists!")
  }

  if (file.info(fidFile)$isdir) {
    stop("Not a fid file! ", sQuote(fidFile), " is a directory.")
  }

  ## try to get absolute file path
  fidFile <- normalizePath(fidFile)

  ## read metadata
  metaData <- .readAcquFile(fidFile=fidFile, verbose=verbose)

  ## read peak intensities
  intensity <- .readFidFile(fidFile, metaData$number, metaData$byteOrder)

  ## some fid files have less intensity values as reported in acqu
  if (length(intensity) < metaData$number) {
    metaData$number <- length(intensity)
    warning("The number of tof/mass values reported in the acqu file is greater ",
            "than the number of intensity values in the fid file. ",
            "The extra tof/mass values are removed.")
  }

  ## calculate tof of metadata
  tof <- as.double(metaData$timeDelay +
                   ((0:(metaData$number-1)) * metaData$timeDelta))

  ## replace negative intensity values by zero
  isNegative <- which(intensity < 0)
  if (!keepNegativeIntensities && length(isNegative)) {
    intensity[isNegative] <- 0
  }

  ## remove times which have no intensity (intensity == 0), e.g. generated by
  ## REFLECTOR mode
  ## for details see "Release Notes for CompassXport 3.0.3"
  ## cap. 6 "Filtering of Zero Intensities"
  ## "Bruker Daltonics' Acquisition Software will compress Analysis raw
  ## data. To save on operation time and to keep export file sizes small,
  ## CompassXport 3.0.3 will filter out zero (0.0) intensities
  ## when exporting to mzXML or mzData ..."
  if (filterZeroIntensities) {
    notNull <- which(intensity > 0)
    intensity <- intensity[notNull]
    tof <- tof[notNull]
  }

  ## TODO: fix V1.0CTOF2 calibration
  ## https://github.com/sgibb/MALDIquantForeign/issues/19
  ## https://github.com/sgibb/readBrukerFlexData/issues/3
  if (isTRUE(metaData$v1tofCalibration)) {
    warning("The spectrum file ", sQuote(fidFile), " uses ",
            "V1.0CTOF2CalibrationConstants.\n",
            "V1.0CTOF2CalibrationConstants aren't fully supported by ",
            "readBrukerFlexFile. See ",
            "https://github.com/sgibb/readBrukerFlexData/issues/3 ",
            "for details.")
    mass <- .ctof2calibration(tof, metaData$v1tofCalibrationConstants)
  } else {
    ## calculate mass of TOFs
    mass <- .tof2mass(tof,
                      metaData$calibrationConstants[[1L]],
                      metaData$calibrationConstants[[2L]],
                      metaData$calibrationConstants[[3L]])
  }

  ## TODO: fix equations in .hpc

  ## was HPC involved?
  ## metaData$hpcUse seems to be always true
  isHPCused <- isTRUE(useHpc & length(metaData$hpcCoefficients))

  if (isHPCused) {
    ## TODO: fix equations in .hpc and remove the following warning
    warning("The spectrum file ", sQuote(fidFile), " uses HPC. ",
            "HPC isn't fully supported by readBrukerFlexFile. ",
            "Please see ", dQuote("?.hpc"), " for details.")
    mass <- .hpc(mass=mass,
                 minMass=metaData$hpcLimits["minMass"],
                 maxMass=metaData$hpcLimits["maxMass"],
                 hpcCoefficients=metaData$hpcCoefficients)
  }

  ## TODO: add LIFT support

  ## was LIFT involved?
  isLIFTused <- isTRUE(all(metaData$lift != 0) || metaData$tlift != 0 ||
                       metaData$spectrumType == "LIFT")

  if (isLIFTused) {
    ## TODO: add LIFT support
    warning("The spectrum file ", sQuote(fidFile), " uses LIFT.\n",
            "LIFT isn't supported by readBrukerFlexFile. ",
            "Could not convert time-of-flight values into mass!")
    mass <- tof
  }

  spectrum <- list(tof=tof, mass=mass, intensity=intensity)

  if (!removeMetaData) {
    return(list(spectrum=spectrum, metaData=metaData))
  } else {
    return(list(spectrum=spectrum, metaData=list(file=metaData$file)))
  }
}

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Extracts values from acqu file.
#'
#' This function is a helper function to extract values from acqu file.
#'
#' @param patternStr \code{character}, pattern to look for
#' @param srcStr \code{character} where to look for \code{patternStr}
#'
#' @return \code{character} vector of the value given in \code{patternStr}
#'
#' @seealso
#'  \code{\link[readBrukerFlexData]{.grepAcquDoubleValue}},
#'  \code{\link[readBrukerFlexData]{.readAcquFile}}
#' @rdname grepAcquValue
#' @keywords internal
.grepAcquValue <- function(patternStr, srcStr) {
  tmpLine <- grep(pattern=patternStr, x=srcStr, value=TRUE)

  ## format e.g.
  ## DATATYPE= CONTINUOUS MASS SPECTRUM
  ## .IONIZATION MODE= LD+
  ## $INSTRUM= <AUTOFLEX>

  ## remove front/back pattern environment
  gsub(pattern="(^.*= *<?)|(>? *$)", replacement="", x=tmpLine)
}

#' Extracts values from acqu file.
#'
#' This function is a helper function to extract double values from acqu file.
#'
#' @param patternStr \code{character}, pattern to look for
#' @param srcStr \code{character} where to look for \code{patternStr}
#'
#' @return \code{double} vector of the value given in \code{patternStr}
#'
#' @seealso
#'  \code{\link[readBrukerFlexData]{.grepAcquValue}},
#'  \code{\link[readBrukerFlexData]{.readAcquFile}}
#' @rdname grepAcquDoubleValue
#' @keywords internal
.grepAcquDoubleValue <- function(patternStr, srcStr) {
  strValue <- .grepAcquValue(patternStr, srcStr)

  ## replace comma by dot
  as.double(gsub(",", replacement=".", strValue))
}

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Extracts High Precision Calibration coefficients.
#'
#' This is a helper function to extract coefficients and constants from
#' metaData$hpcStr.
#'
#' @param hpcStr metaData$hpcStr, which store coefficents
#' \preformatted{
#' hpcStr <- "V1.0CHPCData  Order 10 vCoeff V1.0VectorDouble 11
#'            -0.48579224953906053 0.0009361303203700988
#'            -6.92711401708155e-008 -1.0992953299897006e-009
#'            1.1718229914003113e-012 -5.392578762547374e-016
#'            9.0176664604755316e-020 1.9704001597871883e-023
#'            -1.1794161284667635e-026 2.0351573912658823e-030
#'            -1.2617853301428769e-034
#'            c2 -0.046701600316874939
#'            c0 237.64781433281422
#'            minMass 736.50266799999997
#'            maxMass 3698.6377320000001 bUse 1 endCHPCData"
#' }
#'
#' @return
#'  a \code{list}:
#'  \itemize{
#'    \item{\code{hpcConstants$coefficients}: double, vector of coefficents}
#'    \item{\code{hpcConstants$calibrationConstant0}: c0}
#'    \item{\code{hpcConstants$calibrationConstant2}: c2}
#'  }
#'
#' @seealso \code{\link[readBrukerFlexData]{.hpc}}
#' @rdname extractHPCConstants
#' @keywords internal
#'
.extractHPCConstants <- function(hpcStr) {
  tmpLine <- strsplit(x=hpcStr, split=" ")[[1L]]
  ## remove emtpy elements
  tmpLine <- tmpLine[nzchar(tmpLine)]

  ## extract only coefficients
  list(coefficients=as.double(tmpLine[(which(tmpLine == "V1.0VectorDouble") + 2L):
                           (which(tmpLine == "c2") - 1L)]),
       calibrationConstant0=as.double(tmpLine[which(tmpLine == "c0") + 1L]),
       calibrationConstant2=as.double(tmpLine[which(tmpLine == "c2") + 1L]))
}

#' High Precision Calibration
#'
#' Only basic support (not 100\% identical results) for Bruker Daltonics' HPC.
#' HPC stands for \bold{H}igh \bold{P}recision \bold{C}alibration.\cr
#' This is an internal function and should normally not used by the user.
#'
#' @param mass \code{double}, mass calculated traditionally.
#' @param minMass \code{double}, lower Threshold for HPC. HPC is only defined
#'  for a range of mass.
#' @param maxMass \code{double}, upper Threshold for HPC. HPC is only defined
#'  for a range of mass.
#' @param hpcCoefficients \code{doubles}, coefficients needed by the HPC
#'  algorithm (see also:
#'  \code{\link[readBrukerFlexData]{.extractHPCConstants}})
#' @return A vector of HPC corrected mass (\code{double}).
#'
#' @details
#' Bruker Daltonics doesn't explain how HPC works. All formula are results of
#' \dQuote{trial and error}. That is why mass calculated by \code{.hpc}
#' differs little from original HPC mass.
#' (In example file 214 of 24860 mass are incorrect;
#' deviations: min: 6.103515625e-05, max: 0.02935791015625.) \cr
#' In the manual of mass spectrometry instruments of Bruker Daltonics machines
#' the *flex series you can find an article about HPC principles: \cr
#'  Gobom, J. and Mueller, M. and Egelhofer V. and Theiss, D. and
#'  Lehrach, H. and Nordhoff, E. (2002) \cr
#'  \dQuote{A Calibration Method That Simplifies and Improves Accurate
#'   Determination of Peptide Molecular mass by MALDI-TOF MS.},
#'  \emph{Anal Chem} \bold{74}: 3915-3923 \cr
#'  \url{https://pubmed.ncbi.nlm.nih.gov/12175185/}
#'
#' @note
#' Please note that .hpc is not correct! You have been warned.
#'
#' @references
#'  Gobom, J. and Mueller, M. and Egelhofer V. and Theiss, D. and
#'  Lehrach, H. and Nordhoff, E. (2002) \cr
#'  \dQuote{A Calibration Method That Simplifies and Improves Accurate
#'   Determination of Peptide Molecular mass by MALDI-TOF MS.},
#'  \emph{Anal Chem} \bold{74}: 3915-3923 \cr
#'  \url{https://pubmed.ncbi.nlm.nih.gov/12175185/}
#'
#' @seealso
#'     \code{\link[readBrukerFlexData]{readBrukerFlexDir}},
#'     \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
#'     \code{\link[readBrukerFlexData]{.double2singlePrecision}}
#'
#' @keywords internal
#' @rdname hpc
#' @examples
#' ## load library
#' library("readBrukerFlexData")
#'
#' ## get examples directory
#' exampleDirectory <- system.file("Examples", package="readBrukerFlexData")
#'
#' ## read example spectra
#' ## please note: filterZeroIntensities=TRUE is used for compatibility reasons.
#' ##              You should NOT use it!
#' noHpcSpec <- readBrukerFlexFile(file.path(exampleDirectory,
#'     "hpc/fid/0_A20/1/1SRef/fid"), filterZeroIntensities=TRUE, useHpc=FALSE)
#' hpcSpec <- readBrukerFlexFile(file.path(exampleDirectory,
#'     "hpc/fid/0_A20/1/1SRef/fid"), filterZeroIntensities=TRUE)
#'
#' ## plot spectrum
#' plot(noHpcSpec$spectrum$mass, noHpcSpec$spectrum$intensity, type="l",
#'      col="red", xlim=c(1296, 1300))
#' lines(hpcSpec$spectrum$mass, hpcSpec$spectrum$intensity, type="l",
#'       col="green", xlim=c(1296, 1300))
#' legend(x="topright", legend=c("no hpc", "hpc"), col=c("red", "green"), lwd=1)
#'
#' ## show difference between .hpc and original HPC
#' ## load mzXML generated by Bruker Daltonics CompassXport 1.3.5
#' ## you could do it like this:
#' #library("readMzXmlData")
#' #cpSpecHpcMzXml <- readMzXmlFile(file.path(exampleDirectory,
#' #  "hpc/mzXML/hpc.mzXML"))
#'
#' ## or easily use:
#' data(cpSpecHpcMzXml)
#'
#' ## reduce R double precision to single precision because our CompassXport 1.3.5
#' ## supports only mzXML with precision=32 (only for compatibility reasons)
#' noHpcSpec$spectrum$mass32 <-
#'  readBrukerFlexData:::.double2singlePrecision(noHpcSpec$spectrum$mass)
#' hpcSpec$spectrum$mass32 <-
#'  readBrukerFlexData:::.double2singlePrecision(hpcSpec$spectrum$mass)
#'
#' ## calculate deviance
#' d <- noHpcSpec$spectrum$mass32-cpSpecHpcMzXml$spectrum$mass
#' dHPC <- hpcSpec$spectrum$mass32-cpSpecHpcMzXml$spectrum$mass
#'
#' ## a little summary
#' cat("without .hpc:\n",
#'     "not matching: ", length(cpSpecHpcMzXml$spectrum$mass[d!=0]), " of ",
#'     length(cpSpecHpcMzXml$spectrum$mass), "; range: ",
#'     range(abs(d[d!=0])), "\nwith .hpc:\n",
#'     "not matching: ", length(cpSpecHpcMzXml$spectrum$mass[dHPC!=0]), " of ",
#'     length(cpSpecHpcMzXml$spectrum$mass), "; range: ",
#'     range(abs(d[dHPC!=0])), "\n")
#'
#' ##
#' ## doing things manually
#' ##
#' hpcMass <- readBrukerFlexData:::.hpc(mass=noHpcSpec$spectrum$mass,
#'  minMass=noHpcSpec$metaData$hpc$limits["minMass"],
#'  maxMass=noHpcSpec$metaData$hpc$limits["maxMass"],
#'  hpcCoefficients=noHpcSpec$metaData$hpc$coefficients)
#'
## TODO:
##  - internal calibration (or something like that)
##  - maybe need the following:
##      ##$Hpcgc0= 237.647814332814
##      ##$Hpcgc2= -0.0467016003168749
##
.hpc <- function(mass, minMass, maxMass, hpcCoefficients) {
  ## only defined for mass between minMass and maxMass
  ## QUESTION: Do we exclude values after or before calibration?
  ## ANSWER: I don't know how compassXport do it.
  ##         before: reduce calculation time
  ##         after: produce better results
  ##          I also don't know whether to use >= or > (<=, <).
  hpcRange <- mass >= minMass & mass <= maxMass
  m <- mass[hpcRange]

  ## correction=c[0] + c[1]*cal_mass^1 + ... + c[n]*cal_mass^n
  ## mass=cal_mass - correction
  l <- length(hpcCoefficients) - 1L
  m <- sapply(m, function(x) {
    x - sum(hpcCoefficients * x^(0L:l))
  })

  mass[hpcRange] <- m

  mass
}

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Reads binary fid file.
#'
#' This function reads a binary fid file. A fid file contains intensities for
#' all measured time points.
#'
#'
#' @param fidFile \code{character} path to fid file e.g.
#'  Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid
#' @param nIntensities number of data entries
#'  (total count; get from acqu file)
#' @param endian endianness of the fid file
#'  (\sQuote{little} or \sQuote{big}; default: \sQuote{little})
#'
#' @return
#'  A vector of intensity values.
#' @seealso
#'  \code{\link[readBrukerFlexData]{.readAcquFile}},
#'  \code{\link[readBrukerFlexData]{readBrukerFlexFile}}
#' @keywords internal IO
#' @rdname readFidFile
#'
.readFidFile <- function(fidFile, nIntensities, endian="little") {
  if (!file.exists(fidFile)) {
    stop("File ", sQuote(fidFile), " doesn't exists!")
  }

  con <- file(fidFile, "rb")
  on.exit(close(con))
  as.double(readBin(con, integer(), n=nIntensities, size=4L, endian=endian))
}

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Calculates mass from time-of-flight values.
#'
#' This function calculates mass from time of flight values
#' based on the following article:
#'  Titulaer, M. K. and Siccama, I. and Dekker, J. L. and
#'  van Rijswijk, A. L. and Heeren R. M. and Sillevis Smitt, P. A. and
#'  Luider, T. M. (2006) \cr
#'  \dQuote{A database application for pre-processing, storage and comparison
#'  of mass spectra derived from patients and controls},
#'  \emph{BMC Bioinformatics}, \bold{7}: 403
#'  \url{https://pubmed.ncbi.nlm.nih.gov/16953879/}
#'
#' @details Arguments are imported from metadata (acqu-file).
#'
#' @param tof \code{double}, vector with times-of-flight
#' @param c1 metaData$calibrationConstants[1]
#' @param c2 metaData$calibrationConstants[2]
#' @param c3 metaData$calibrationConstants[3]
#'
#' @return \code{double}, calculated mass
#' @keywords internal
#' @rdname tof2mass
#' @references
#'  Titulaer, M. K. and Siccama, I. and Dekker, J. L. and
#'  van Rijswijk, A. L. and Heeren R. M. and Sillevis Smitt, P. A. and
#'  Luider, T. M. (2006) \cr
#'  \dQuote{A database application for pre-processing, storage and comparison
#'  of mass spectra derived from patients and controls},
#'  \emph{BMC Bioinformatics}, \bold{7}: 403
#'  \url{https://pubmed.ncbi.nlm.nih.gov/16953879/}
#'
.tof2mass <- function(tof, c1, c2, c3) {
  A <- c3
  B <- sqrt(1e+12/c1)
  C <- c2 - tof

  if (A == 0) {
    ## linear: 0 = B * sqrt(m/z) + C(times)
    return((C * C)/(B * B))
  } else {
    ## quadratic: 0 = A * (sqrt(m/z))^2 + B * sqrt(m/z) + C(times)
    return(((-B + sqrt((B * B) - (4 * A * C)))/(2 * A))^2)
  }
}

## Copyright 2010-2014 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' The readBrukerFlexData Package
#'
#' The readBrukerFlexData package reads data files acquired by MALDI-TOF MS on
#' Bruker Daltonics machines of the *flex series. (autoflex,
#' microflex, ultraflex). \cr
#' The package was developed \emph{without} any knowledge nor even support by
#' Bruker Daltonics.
#' \cr \cr
#' All trademarks are owned by or licensed to Bruker Daltonics.
#'
#' @name readBrukerFlexData-package
#' @author Sebastian Gibb \email{mail@@sebastiangibb.de}
#' @references \url{https://github.com/sgibb/readBrukerFlexData}
#' @keywords package
#' @rdname readBrukerFlexData-package
#'
"_PACKAGE"

#' These functions are defunct and no longer available.
#'
#' \describe{
#'  \item{mqReadBrukerFlex:}{use
#'    \code{\link[MALDIquantForeign]{importBrukerFlex}} instead.}
#' }
#'
#' @title Removed functions in package \pkg{readBrukerFlexData}
#' @keywords internal
#' @name readBrukerFlexData-defunct
#' @aliases mqReadBrukerFlex
#' @rdname readBrukerFlexData-defunct
#'
NULL

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <http://www.gnu.org/licenses/>

#' Reads mass spectrometry data into MALDIquant.
#'
#' This function is deprecated and will be removed in the next release.
#' Use \code{\link[MALDIquantForeign]{importBrukerFlex}} instead. \cr
#' This function reads all mass spectrometry data in
#' Bruker Daltonics XMASS format in a specified path into
#' \code{\link[MALDIquant]{MALDIquant-package}} 
#' \code{\link[MALDIquant]{MassSpectrum-class}} objects.
#'
#' @details
#' See \code{\link[readBrukerFlexData]{readBrukerFlexDir}} or
#' \code{\link[readBrukerFlexData]{readBrukerFlexFile}}.
#' 
#' @param path \code{character}, path to \emph{directory} or a single
#'  \emph{fid} file.
#' @param \ldots arguments to be passed to
#'  \code{\link[readBrukerFlexData]{readBrukerFlexDir}} or
#'  \code{\link[readBrukerFlexData]{readBrukerFlexFile}} 
#' 
#' @return
#'  a \code{list} of \code{\link[MALDIquant]{MassSpectrum-class}} objects.
#'
#' @references
#' See website: \url{http://strimmerlab.org/software/maldiquant/}
#'
#' @seealso
#' \code{\link[readBrukerFlexData]{readBrukerFlexDir}},
#' \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
#' \code{\link[MALDIquant]{MALDIquant-package}},
#' \code{\link[MALDIquant]{MassSpectrum-class}}
#' @keywords IO
#' @aliases mqReadBrukerFlex-deprecated
#' @rdname mqReadBrukerFlex
#' @export
mqReadBrukerFlex <- function(path, ...) {
  .Deprecated("MALDIquantForeign::importBrukerFlex")

  if (!file.exists(path)) {
    stop("Path ", sQuote(path), " doesn't exists!")
  }
  
  if (!require("MALDIquant")) {
    stop("Could not load package ", sQuote("MALDIquant"), ".")
  }
  
  if (!file.info(path)$isdir) {
    s <- readBrukerFlexFile(fidFile=path, ...)
    return(list(createMassSpectrum(mass=s$spectrum$mass, 
                                   intensity=s$spectrum$intensity, 
                                    metaData=s$metaData)))
  } else {
    s <- readBrukerFlexDir(brukerFlexDir=path, ...)
    s <- lapply(s, function(x) {
      return(createMassSpectrum(mass=x$spectrum$mass, 
                                intensity=x$spectrum$intensity, 
                                metaData=x$metaData))
    })
    return(s)
  }
}
 

## Copyright 2010-2014 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Reads an acqu file.
#'
#' This function reads constants, calibrations values and a lot of more from
#' \emph{acqu} files.
#'
#' @param fidFile \code{character}, path to corresponding fid file
#'  (e.g. \code{Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid})
#' @param verbose \code{logical}, print verbose messages?
#'
#' @return
#'  a \code{list} with metadata
#'
#' @seealso \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
#' @rdname readAcquFile
#' @keywords internal IO
#'
##  We have to import the following data to calculating mass:
##  $BYTORDA: endianness, 0==little, 1==big
##      => metaData$byteOrder
##  $TD: total number of measured time periods
##      => metaData$number
##  $DELAY: first measured intensity after $DELAY ns
##      => metaData$timeDelay
##  $DW: ns between measured time periods
##      => metaData$timeDelta
##  $ML1: calibration constant
##      => metaData$calibrationConstants[1]
##  $ML2: calibration constant
##      => metaData$calibrationConstants[2]
##  $ML3: calibration constant
##      => metaData$calibrationConstants[3]
##
##  if we want to use High Precision Calibration (HPC), we need:
##  $HPClBHi: upper mass threshold
##      => metaData$hpcLimits["maxMass"]
##  $HPClBLo: lower mass threshold
##      => metaData$hpcLimits["minMass"]
##  $HPClOrd: polynomial order
##      => metaData$hpcOrder
##  $HPClUse: maybe using of HPC? (seems always be "yes" in our test data)
##      => metaData$hpcUse
##  $HPCStr: polynomial coefficients in a string
##      => metaData$hpcCoefficients
##
##  we try to import [optional]:
##  DATATYPE
##  SPECTROMETER/DATASYSTEM
##      => metaData$dataSystem
##  .SPECTROMETER TYPE
##      => metaData$spectrometerType
##  .INLET
##      => metaData$inlet
##  .IONIZATION MODE
##      => metaData$ionizationMode
##  $DATE
##      => metaData$date
##  $ACQMETH
##      => metaData$acquisitionMethod
##  $AQ_DATE
##      => metaData$acquisitionDate
##  $AQ_mod
##      => metaData$acquisitionMode
##  $AQOP_mod
##      => metaData$acquisitionOperatorMode
##      => metaData$tofMode (replaces file path based method)
##  $ATTEN
##      => metaData$laserAttenuation
##  $COM[1:4]
##      => metaData$comments
##  $DEFLON
##      => metaData$deflection
##  $DIGTYP
##      => metaData$digitizerType
##  $DPCAL1
##      => metaData$deflectionPulserCal1
##  $DPMASS
##      => metaData$deflectionPulserMass
##  $FCVer
##      => metaData$flexControlVersion
##  $ID_raw
##      => metaData$id
##  $INSTRUM
##      => metaData$instrument
##  $InstrID
##      => metaData$instrumentId
##  $InstrTyp
##      => metaData$instrumentType
##  $Masserr
##      => metaData$massError
##  $NoSHOTS: number of laser shots
##      => metaData$laserShots
##  $SPType
##      => metaData$spectrumType
##  $PATCHNO: sample position on target
##      => metaData$patch
##  $PATH: original file path (on Bruker flex series controller PC)
##      => metaData$path
##  $REPHZ
##      => metaData$laserRepetition
##  $SPOTNO: same as $PATCHNO (in older files often empty, that's why we use
##      $PATCHNO instead)
##      => metaData$spot
##  $TgIDS: target ids
##      => metaData$targetIdString
##  $TgCount: number of measurement with this target
##      => metaData$targetCount
##  $TgSer: target serial number
##      => metaData$targetSerialNumber
##  $TgTyp: target type number
##      => metaData$targetTypeNumber
##
##  import from file path:
##  full current path to fid file:
##      => metaData$fidFile
##  sample name
##      => metaData$sampleName
##
.readAcquFile <- function(fidFile, verbose=FALSE) {
  acquFile <- sub(pattern="fid$", x=fidFile, replacement="acqu")
  acquFiles <- c(acquFile, paste0(acquFile, "s"))
  acquFile <- acquFiles[which.max(file.exists(acquFiles))]

  if (!file.exists(acquFile)) {
    stop("File ", sQuote(acquFile), " doesn't exists!")
  }

  if (verbose) {
    message("Reading metadata from ", sQuote(acquFile), " ...")
  }

  con <- file(acquFile, "rt")
  acquLines <- readLines(con, n=-1)
  close(con)

  ## collect data
  metaData <- list()

  ## endianness
  isBigEndian <- as.integer(.grepAcquValue("##\\$BYTORDA=", acquLines)) == 1L
  metaData$byteOrder <- ifelse(isBigEndian, "big", "little")

  ## obligate
  metaData$number <- as.double(.grepAcquValue("##\\$TD=", acquLines))
  metaData$timeDelay <- .grepAcquDoubleValue("##\\$DELAY=", acquLines)
  metaData$timeDelta <- .grepAcquDoubleValue("##\\$DW=", acquLines)
  metaData$calibrationConstants <-
    c(c1=.grepAcquDoubleValue("##\\$ML1=", acquLines),
      c2=.grepAcquDoubleValue("##\\$ML2=", acquLines),
      c3=.grepAcquDoubleValue("##\\$ML3=", acquLines))

  ## obligate HPC
  metaData$hpcLimits <-
    c(minMass=.grepAcquDoubleValue("##\\$HPClBLo=", acquLines),
      maxMass=.grepAcquDoubleValue("##\\$HPClBHi=", acquLines))
  metaData$hpcOrder <- as.double(.grepAcquValue("##\\$HPClOrd=", acquLines))
  metaData$hpcUse <-
    as.logical(.grepAcquValue("##\\$HPClUse=", acquLines) == "yes")

  ## was HPC involved?  metaData$hpcUse seems to be always true
  isHPCused <- isTRUE(metaData$hpcUse &&
                      metaData$hpcLimits["maxMass"] > 0L &&
                      metaData$hpcLimits["minMass"] > 0L &&
                      metaData$hpcOrder > 0L)

  if (isHPCused) {
    hpcStr <- .grepAcquValue("##\\$HPCStr=", acquLines)
    hpcConstants <- .extractHPCConstants(hpcStr)
    metaData$hpcCoefficients <- hpcConstants$coefficients
    metaData$hpcCalibrationConstant0 <- hpcConstants$calibrationConstant0
    metaData$hpcCalibrationConstant2 <- hpcConstants$calibrationConstant2
  }

  # https://github.com/sgibb/MALDIquantForeign/issues/19
  # https://github.com/sgibb/readBrukerFlexData/issues/3
  metaData$v1tofCalibration <-
    grepl("V1.0CTOF2CalibrationConstants",
          .grepAcquValue("##\\$NTBCal=", acquLines))
  metaData$v1tofCalibrationConstants <-
    .extractV10CTOF2CalibrationConstants(
      .grepAcquValue("##\\$NTBCal=", acquLines)
    )

  ## obligate LIFT
  metaData$lift <- c(.grepAcquDoubleValue("##\\$Lift1=", acquLines),
                     .grepAcquDoubleValue("##\\$Lift2=", acquLines))
  metaData$tlift <- .grepAcquDoubleValue("##\\$TLift=", acquLines)

  ## optional
  metaData$dataType <- .grepAcquValue("##DATATYPE=", acquLines)
  metaData$dataSystem <- .grepAcquValue("##SPECTROMETER/DATASYSTEM=", acquLines)
  metaData$spectrometerType <-
    .grepAcquValue("##.SPECTROMETER TYPE=", acquLines)
  metaData$inlet <- .grepAcquValue("##.INLET=", acquLines)
  metaData$ionizationMode <- .grepAcquValue("##.IONIZATION MODE=", acquLines)
  metaData$date <- .grepAcquValue("##\\$DATE=", acquLines)


  metaData$acquisitionMethod <- .grepAcquValue("##\\$ACQMETH=", acquLines)
  metaData$acquisitionDate <- .grepAcquValue("##\\$AQ_DATE=", acquLines)
  aq_mod <- .grepAcquValue("##\\$AQ_mod=", acquLines)
  if (length(aq_mod)) {
    metaData$acquisitionMode <- switch(aq_mod,
      "0" = { "qf" },
      "1" = { "qsim" },
      "2" = { "qseq" },
      { aq_mod }
    )
  }

  aqop <- .grepAcquValue("##\\$AQOP_m=", acquLines)
  if (length(aqop)) {
    metaData$tofMode  <- switch(aqop,
      "0" = { "LINEAR" },
      "1" = { "REFLECTOR" },
      { aqop }
    )
  }

  metaData$acquisitionOperatorMode <- metaData$tofMode

  metaData$laserAttenuation <- .grepAcquDoubleValue("##\\$ATTEN=", acquLines)

  metaData$comments <- .grepAcquValue("##\\$CMT.*=", acquLines)

  metaData$deflection <-
    as.logical(.grepAcquValue("##\\$DEFLON=", acquLines) == "yes")

  digtyp  <- .grepAcquValue("##\\$DIGTYP=", acquLines)
  if (length(digtyp)) {
    metaData$digitizerType <- switch(digtyp,
        "0" = { "unknown" },
        "1" = { "Lecroy LSA1000" },
        "2" = { "Acqiris DP105" },
        "3" = { "Acqiris DP110" },
        "4" = { "Acqiris DP211" },
        "5" = { "Acqiris DP240" },
        "6" = { "Acqiris AP200" },
        "7" = { "Acqiris AP240" },
        "8" = { "Acqiris DC440" },
        "9" = { "Acqiris DC282" },
       "10" = { "Acqiris Unknown subtype" },
       "11" = { "Gage" },
       "12" = { "Simulator" },
       "13" = { "Lecroy WaveRunner" },
       "14" = { "Acqiris U1084A" },
       "15" = { "NI 5154" },
       "16" = { "LeCroy LSA2000" },
       "17" = { "Acqiris DP1400" },
       "18" = { "NI 5155" },
       "19" = { "Bruker BD0G5" },
        { digtyp }
    )
  }

  metaData$deflectionPulserCal1 <-
    .grepAcquDoubleValue("##\\$DPCAL1=", acquLines)
  metaData$deflectionPulserMass <-
    .grepAcquDoubleValue("##\\$DPMASS=", acquLines)
  metaData$flexControlVersion <- .grepAcquValue("##\\$FCVer=", acquLines)
  metaData$id <- .grepAcquValue("##\\$ID_raw=", acquLines)

  metaData$instrument <- .grepAcquValue("##\\$INSTRUM=", acquLines)
  metaData$instrumentId <- .grepAcquValue("##\\$InstrID=", acquLines)

  instrumentType <- .grepAcquValue("##\\$InstTyp=", acquLines)
  if (length(instrumentType)) {
    metaData$instrumentType <- switch(instrumentType,
        "0" = { "autoflex" },
        "1" = { "ultraflex" },
        "2" = { "ultraflexTOF/TOF" },
        "3" = { "reflex" },
        "4" = { "biflex" },
        "5" = { "omniflex" },
        "6" = { "genoflex" },
        "7" = { "massarray" },
        "8" = { "autoflexTOF/TOF" },
        "9" = { "microflex" },
       "10" = { "MT10" },
        { instrumentType }
    )
  }

  metaData$massError <- .grepAcquDoubleValue("##\\$Masserr=", acquLines)

  metaData$laserShots <- as.double(.grepAcquValue("##\\$NoSHOTS=", acquLines))

  if (metaData$laserShots == 0L) {
    warning("File ", sQuote(fidFile), " seems to be empty because ",
            "no laser shots applied to this sample.")
  }

  metaData$patch <- .grepAcquValue("##\\$PATCHNO=", acquLines)

  ## imaging data
  if (length(metaData$patch) &&
      grepl(pattern="(R[0-9]+)?X[0-9]+Y[0-9]+", x=metaData$patch,
            ignore.case=TRUE)) {
    rx <- gregexpr(pattern="[XY][0-9]+", text=metaData$patch)[[1L]]
    pos <- substring(metaData$patch, rx+1L, rx+attr(rx, "match.length")-1L)

    if (length(pos) == 2L) {
      pos <- as.double(pos)
      metaData$imaging <- list(pos=c(x=pos[1L], y=pos[2L]))
    }
  }

  metaData$path <- .grepAcquValue("##\\$PATH=", acquLines)
  metaData$laserRepetition <- .grepAcquDoubleValue("##\\$REPHZ=", acquLines)
  metaData$spot <- .grepAcquValue("##\\$SPOTNO=", acquLines)

  sptype <- .grepAcquValue("##\\$SPType=", acquLines)
  if (length(sptype)) {
    metaData$spectrumType <- switch(sptype,
      "0" = { "TOF" },
      "1" = { "PSD" },
      "2" = { "LIFT" },
      "3" = { "PSDSegment" },
      { sptype }
    )
  }

  metaData$targetCount <- as.double(.grepAcquValue("##\\$TgCount", acquLines))
  metaData$targetIdString <- .grepAcquValue("##\\$TgIDS", acquLines)
  metaData$targetSerialNumber <- .grepAcquValue("##\\$TgSer", acquLines)
  metaData$targetTypeNumber <- .grepAcquValue("##\\$TgTyp", acquLines)

  metaData$file <- fidFile

  metaData$sampleName <- .sampleName(fidFile)
  metaData$fullName <- paste(metaData$sampleName, metaData$patch, sep=".")
  metaData$name <- metaData$fullName

  metaData
}

#' Extracts NTBCal coefficients.
#'
#' This is a helper function to extract coefficients and constants from
#' `metaData$NtbCalStr`.
#'
#' @param x \code{character}, NTBCal line
#'
#' \preformatted{
#' "##$NTBCal= <V3.0CCalibrator 12 1 0 0 -2147483648 2147483647  V1.0CHPCData  Order 0 vCoeff V1.0VectorDouble 0  c2 0 c0 0 minMass 0 maxMass 0 bUse 0 endCHPCData V1.0CTOF2CalibrationConstants 48 0.25 3884.868239229128 1164156.9998801197 6.1682474689786355 -0.063083671657452864 -34.362308485323794 2 V1.0CTOF2CalibrationConstants 0 0 0 0 0 0 0 -1  >"
#' }
#'
#' @return a \code{double}, coefficients
#'
#' @seealso \code{\link[readBrukerFlexData]{.ctof2calibration}}
#' @noRd
#' @keywords internal
#' @return \code{double}, vector of the calibration constants.
#'
#' @keywords internal
#' @noRd
.extractV10CTOF2CalibrationConstants <- function(x) {
    x <- gsub("^.*V1.0CTOF2CalibrationConstants ([0-9. -]*) V1.0CTOF2CalibrationConstants.*$", "\\1", x)
    ## suppress warnings about NA introduction for empty strings
    suppressWarnings(as.numeric(unlist(strsplit(x, " ", fixed = TRUE))))
}

#' Cubic calibration
#'
#' Only basic support (not 100\% identical results) for Bruker Daltonics' cubic
#' calibration (encoded in `"##$NTBCal"` as `"V1.0CTOF2CalibrationConstants"`).
#' This is an internal function and should normally not used by the user.
#'
#' @param tof \code{double}, time of flight.
#' @param d \code{double}, calibration constants, return value of
#' \code{.extractV10CTOF2CalibrationConstants}.
#' @return \code{double}, mz values.
#'
#' @note
#' Bruker Daltonics doesn't explain how the cubic calibration works.
#' All formula are results of \dQuote{trial and error}.
#' That is why mass calculated by \code{.ctof2calibration}
#' differs little from original mass.
#' See also \url{https://github.com/sgibb/readBrukerFlexData/issues/3}.
#'
#' @seealso
#' \url{https://github.com/sgibb/readBrukerFlexData/issues/3}
#'
#' @author
#' Alan Race, Samuel Granjeaud, Sebastian Gibb
#'
#' @keywords internal
#' @rdname ctof2calibration
.ctof2calibration <- function(tof, d) {
    ## e.g.  "V1.0CTOF2CalibrationConstants 48 0.25 3884.868239229128 1164156.9998801197 6.1682474689786355 -0.063083671657452864 -34.362308485323794 2 V1.0CTOF2CalibrationConstants"
    ## DELAY DW ML2 ML1 ML3 A E 2

    A <- d[6]
    B <- d[5]
    C <- sqrt(1e12 / d[4])
    D <- d[3]
    E <- d[7]

    ## quadratic: 0 = B * (sqrt(m/z))^2 + C * sqrt(m/z) + D(times)
    ## same formula as tof2mass but instead of D(times) = ML3 - tof
    ## it seems to be necessary to use D(times) = tof - ML3
    ## abs(tof - ML3) seems to be not equivalent
    ## m <- .tof2mass(tof, d[4], d[3], d[5])
    m <- (-C + sqrt(abs((C * C) - (4 * B * (tof - D))))) / (2 * B)

    s <- sign(tof - D)
    belowZero <- s < 0

    m[!belowZero] <- vapply(tof[!belowZero], function(x) {
        ## Assuming cubic with A*x^3 + B*x^2 + C*x + (D - tof)
        ## where x = sqrt(mz)
        Re(polyroot(c(D - x, C, B, A))[1L])
    }, NA_real_)

    m^2 * s - E
}

## Copyright 2010-2012 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Converts double to single precision.
#'
#' This function simulates the conversion of floating point numbers from double
#' precision (64bit, R: \code{double()}, C: \code{double}) to single precision
#' (32bit, R: \code{none}, C: \code{float}). It follows IEEE 754 standard.
#'
#' @param x \code{double}, numeric value which should reduce from double
#'  precision to single precision.
#' @return \code{double} (in single precision).
#'
#' @details
#' The same could be done in C by using casts:
#' \preformatted{
#' double precision32(double value) {
#'   float x=value;
#'   return (double)x;
#' }}
#' @seealso \code{\link[readBrukerFlexData]{.changePrecision}},
#'  \code{\link[readBrukerFlexData]{.hpc}}
#' @rdname double2singlePrecision
#' @keywords internal
#' @references
#' IEEE 754 standard: \url{https://ieeexplore.ieee.org/xpl/articleDetails.jsp?arnumber=30711&filter=AND(p_Publication_Number:2355)}
#' @examples
#' ## load library
#' library("readBrukerFlexData")
#'
#' ## show more details
#' oldDigits <- options()$digits
#' options(digits=22)
#'
#' ## a test number
#' num <- 1/3
#'
#' num
#' readBrukerFlexData:::.double2singlePrecision(num)
#'
#' ## reset digits option
#' options(digits=oldDigits)
#'
.double2singlePrecision <- function(x) {
  stopifnot(is.double(x))
  .changePrecision(x, size=4L)
}

#' Change precision.
#'
#' This function converts double values to double values in a given
#' precision (only correctly working for cut a higher precision to a lower one;
#' e.g.  IEEE 754 double precision to IEEE 754 single precision)
#'
#' @param x \code{double}, a vector of double values which should converted.
#' @param size \code{integer}, how many bytes using for target precision
#'  e.g. IEEE 754 single precision: \code{size=4},
#'  IEEE 754 double precision: \code{size=8}
#' @return \code{double}.
#' @seealso \code{\link[readBrukerFlexData]{.double2singlePrecision}},
#' @rdname changePrecision
#' @keywords internal
#'
.changePrecision <- function(x, size) {
  ## create a raw object to avoid direct file access
  virtualCon <- raw()
  ## write binary data to raw object and change (mostly cut) precision to size
  ## size==4 # 32bit, single precision
  ## size==8 # 64bit, double precision
  virtualCon <- writeBin(object=x, con=virtualCon, size=size)
  ## re-read data
  readBin(con=virtualCon, what=double(), size=size, n=length(x))
}

## Copyright 2010-2014 Sebastian Gibb
## <mail@sebastiangibb.de>
##
## This file is part of readBrukerFlexData for R and related languages.
##
## readBrukerFlexData is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## readBrukerFlexData is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with readBrukerFlexData. If not, see <https://www.gnu.org/licenses/>

#' Creates sample name.
#'
#' This function guesses the name of current spot from filename.
#'
#' @note WARNING: if the 4th upper directory hasn't an unique name you will get
#'  equal names for your spot list
#'
#'  e.g. the following will create a list with 4 elements but
#'  only 2 unique spot names (2-100kDa:0_A1 and 2-100kDa:0_B1) \cr
#' ./Run1/2-100kDa/0_A1/1/1SLin/fid \cr
#' ./Run1/2-100kDa/0_B1/1/1SLin/fid \cr
#' ./Run2/2-100kDa/0_A1/1/1SLin/fid \cr
#' ./Run2/2-100kDa/0_B1/1/1SLin/fid \cr
#'
#' @param fidFile \code{character}, path to fid file
#'  (e.g. \sQuote{Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid})
#'
#' @return
#'  \code{character}, sample name: e.g \sQuote{Pankreas_HB_L_061019_A10}
#'
#' @seealso
#'  \code{\link[readBrukerFlexData]{.readAcquFile}},
#'  \code{\link[readBrukerFlexData]{readBrukerFlexFile}}
#' @keywords internal
#' @rdname sampleName
#'
.sampleName <- function(fidFile) {
  # regular expression for directory separator (on unix: /+, on windows \+)
  # sadly .Platform$file.sep == "/" on both
  fidFile <- chartr(old="\\", new="/", x=fidFile)

  # create array of directories (each element == one directory)
  dirs <- strsplit(x=fidFile, split="/")[[1L]]

  numDirs <- length(dirs)

  sampleName <- NA

  ## old FlexAnalysis seems to have the following directories
  ## 0_L20_1SLin/fid
  ## vs the more recent FlexAnalysis versions use
  ## 0/L20/1SLin/fid
  isShortPath <- isTRUE(numDirs > 2L &&
                        grepl("[0-9]+_[A-z][0-9]+_[0-9][A-z]+$",
                              dirs[numDirs - 1L]))
  if (isShortPath) {
    sampleName <- dirs[numDirs-2L]
  } else if (numDirs > 4L ) {
    sampleName <- dirs[numDirs-4L]

    # -, : or something like that causes errors in names()
    # TODO: use make.names in future releases?
    sampleName <- gsub(pattern="[[:punct:]]|[[:space:]]", replacement="_",
                       x=sampleName)
  }

  sampleName
}

test_that("sampleName", {
    files <- c(
        "./Run1/2-100kDa/0_A1/1/1SLin/fid",
        "foo/Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid",
        "LT_1631_05_smear/0_H1_1SLin/fid"
    )
    name <- c("2_100kDa", "Pankreas_HB_L_061019_A10", "LT_1631_05_smear")

    for (i in seq(along=files))
        expect_equal(.sampleName(files[i]), name[i])
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hpc-functions.R
\name{.hpc}
\alias{.hpc}
\title{High Precision Calibration}
\usage{
.hpc(mass, minMass, maxMass, hpcCoefficients)
}
\arguments{
\item{mass}{\code{double}, mass calculated traditionally.}

\item{minMass}{\code{double}, lower Threshold for HPC. HPC is only defined
for a range of mass.}

\item{maxMass}{\code{double}, upper Threshold for HPC. HPC is only defined
for a range of mass.}

\item{hpcCoefficients}{\code{doubles}, coefficients needed by the HPC
algorithm (see also:
\code{\link[readBrukerFlexData]{.extractHPCConstants}})}
}
\value{
A vector of HPC corrected mass (\code{double}).
}
\description{
Only basic support (not 100\% identical results) for Bruker Daltonics' HPC.
HPC stands for \bold{H}igh \bold{P}recision \bold{C}alibration.\cr
This is an internal function and should normally not used by the user.
}
\details{
Bruker Daltonics doesn't explain how HPC works. All formula are results of
\dQuote{trial and error}. That is why mass calculated by \code{.hpc}
differs little from original HPC mass.
(In example file 214 of 24860 mass are incorrect;
deviations: min: 6.103515625e-05, max: 0.02935791015625.) \cr
In the manual of mass spectrometry instruments of Bruker Daltonics machines
the *flex series you can find an article about HPC principles: \cr
 Gobom, J. and Mueller, M. and Egelhofer V. and Theiss, D. and
 Lehrach, H. and Nordhoff, E. (2002) \cr
 \dQuote{A Calibration Method That Simplifies and Improves Accurate
  Determination of Peptide Molecular mass by MALDI-TOF MS.},
 \emph{Anal Chem} \bold{74}: 3915-3923 \cr
 \url{https://pubmed.ncbi.nlm.nih.gov/12175185/}
}
\note{
Please note that .hpc is not correct! You have been warned.
}
\examples{
## load library
library("readBrukerFlexData")

## get examples directory
exampleDirectory <- system.file("Examples", package="readBrukerFlexData")

## read example spectra
## please note: filterZeroIntensities=TRUE is used for compatibility reasons.
##              You should NOT use it!
noHpcSpec <- readBrukerFlexFile(file.path(exampleDirectory,
    "hpc/fid/0_A20/1/1SRef/fid"), filterZeroIntensities=TRUE, useHpc=FALSE)
hpcSpec <- readBrukerFlexFile(file.path(exampleDirectory,
    "hpc/fid/0_A20/1/1SRef/fid"), filterZeroIntensities=TRUE)

## plot spectrum
plot(noHpcSpec$spectrum$mass, noHpcSpec$spectrum$intensity, type="l",
     col="red", xlim=c(1296, 1300))
lines(hpcSpec$spectrum$mass, hpcSpec$spectrum$intensity, type="l",
      col="green", xlim=c(1296, 1300))
legend(x="topright", legend=c("no hpc", "hpc"), col=c("red", "green"), lwd=1)

## show difference between .hpc and original HPC
## load mzXML generated by Bruker Daltonics CompassXport 1.3.5
## you could do it like this:
#library("readMzXmlData")
#cpSpecHpcMzXml <- readMzXmlFile(file.path(exampleDirectory,
#  "hpc/mzXML/hpc.mzXML"))

## or easily use:
data(cpSpecHpcMzXml)

## reduce R double precision to single precision because our CompassXport 1.3.5
## supports only mzXML with precision=32 (only for compatibility reasons)
noHpcSpec$spectrum$mass32 <-
 readBrukerFlexData:::.double2singlePrecision(noHpcSpec$spectrum$mass)
hpcSpec$spectrum$mass32 <-
 readBrukerFlexData:::.double2singlePrecision(hpcSpec$spectrum$mass)

## calculate deviance
d <- noHpcSpec$spectrum$mass32-cpSpecHpcMzXml$spectrum$mass
dHPC <- hpcSpec$spectrum$mass32-cpSpecHpcMzXml$spectrum$mass

## a little summary
cat("without .hpc:\n",
    "not matching: ", length(cpSpecHpcMzXml$spectrum$mass[d!=0]), " of ",
    length(cpSpecHpcMzXml$spectrum$mass), "; range: ",
    range(abs(d[d!=0])), "\nwith .hpc:\n",
    "not matching: ", length(cpSpecHpcMzXml$spectrum$mass[dHPC!=0]), " of ",
    length(cpSpecHpcMzXml$spectrum$mass), "; range: ",
    range(abs(d[dHPC!=0])), "\n")

##
## doing things manually
##
hpcMass <- readBrukerFlexData:::.hpc(mass=noHpcSpec$spectrum$mass,
 minMass=noHpcSpec$metaData$hpc$limits["minMass"],
 maxMass=noHpcSpec$metaData$hpc$limits["maxMass"],
 hpcCoefficients=noHpcSpec$metaData$hpc$coefficients)

}
\references{
Gobom, J. and Mueller, M. and Egelhofer V. and Theiss, D. and
 Lehrach, H. and Nordhoff, E. (2002) \cr
 \dQuote{A Calibration Method That Simplifies and Improves Accurate
  Determination of Peptide Molecular mass by MALDI-TOF MS.},
 \emph{Anal Chem} \bold{74}: 3915-3923 \cr
 \url{https://pubmed.ncbi.nlm.nih.gov/12175185/}
}
\seealso{
\code{\link[readBrukerFlexData]{readBrukerFlexDir}},
    \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
    \code{\link[readBrukerFlexData]{.double2singlePrecision}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readFidFile-functions.R
\name{.readFidFile}
\alias{.readFidFile}
\title{Reads binary fid file.}
\usage{
.readFidFile(fidFile, nIntensities, endian = "little")
}
\arguments{
\item{fidFile}{\code{character} path to fid file e.g.
Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid}

\item{nIntensities}{number of data entries
(total count; get from acqu file)}

\item{endian}{endianness of the fid file
(\sQuote{little} or \sQuote{big}; default: \sQuote{little})}
}
\value{
A vector of intensity values.
}
\description{
This function reads a binary fid file. A fid file contains intensities for
all measured time points.
}
\seealso{
\code{\link[readBrukerFlexData]{.readAcquFile}},
 \code{\link[readBrukerFlexData]{readBrukerFlexFile}}
}
\keyword{IO}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grepAcquValue-functions.R
\name{.grepAcquValue}
\alias{.grepAcquValue}
\title{Extracts values from acqu file.}
\usage{
.grepAcquValue(patternStr, srcStr)
}
\arguments{
\item{patternStr}{\code{character}, pattern to look for}

\item{srcStr}{\code{character} where to look for \code{patternStr}}
}
\value{
\code{character} vector of the value given in \code{patternStr}
}
\description{
This function is a helper function to extract values from acqu file.
}
\seealso{
\code{\link[readBrukerFlexData]{.grepAcquDoubleValue}},
 \code{\link[readBrukerFlexData]{.readAcquFile}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readAcquFile-functions.R
\name{.readAcquFile}
\alias{.readAcquFile}
\title{Reads an acqu file.}
\usage{
.readAcquFile(fidFile, verbose = FALSE)
}
\arguments{
\item{fidFile}{\code{character}, path to corresponding fid file
(e.g. \code{Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid})}

\item{verbose}{\code{logical}, print verbose messages?}
}
\value{
a \code{list} with metadata
}
\description{
This function reads constants, calibrations values and a lot of more from
\emph{acqu} files.
}
\seealso{
\code{\link[readBrukerFlexData]{readBrukerFlexFile}},
}
\keyword{IO}
\keyword{internal}

\name{mqReadBrukerFlex}
\alias{mqReadBrukerFlex}
\alias{mqReadBrukerFlex-deprecated}
\title{Reads mass spectrometry data into MALDIquant.}
\usage{
  mqReadBrukerFlex(path, ...)
}
\arguments{
  \item{path}{\code{character}, path to \emph{directory} or
  a single \emph{fid} file.}

  \item{\ldots}{arguments to be passed to
  \code{\link[readBrukerFlexData]{readBrukerFlexDir}} or
  \code{\link[readBrukerFlexData]{readBrukerFlexFile}}}
}
\value{
  a \code{list} of
  \code{\link[MALDIquant]{MassSpectrum-class}} objects.
}
\description{
  This function is deprecated and will be removed in the
  next release. Use
  \code{\link[MALDIquantForeign]{importBrukerFlex}}
  instead. \cr This function reads all mass spectrometry
  data in Bruker Daltonics XMASS format in a specified path
  into \code{\link[MALDIquant]{MALDIquant-package}}
  \code{\link[MALDIquant]{MassSpectrum-class}} objects.
}
\details{
  See \code{\link[readBrukerFlexData]{readBrukerFlexDir}}
  or \code{\link[readBrukerFlexData]{readBrukerFlexFile}}.
}
\references{
  See website:
  \url{http://strimmerlab.org/software/maldiquant/}
}
\seealso{
  \code{\link[readBrukerFlexData]{readBrukerFlexDir}},
  \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
  \code{\link[MALDIquant]{MALDIquant-package}},
  \code{\link[MALDIquant]{MassSpectrum-class}}
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readBrukerFlexDir-functions.R
\name{readBrukerFlexDir}
\alias{readBrukerFlexDir}
\title{Reads recursively mass spectrometry data in Bruker Daltonics XMASS format.}
\usage{
readBrukerFlexDir(
  brukerFlexDir,
  removeCalibrationScans = TRUE,
  removeMetaData = FALSE,
  useHpc = TRUE,
  useSpectraNames = TRUE,
  filterZeroIntensities = FALSE,
  verbose = FALSE
)
}
\arguments{
\item{brukerFlexDir}{\code{character}, path to \emph{directory} which
should be read recursively.}

\item{removeCalibrationScans}{\code{logical}, if \code{TRUE} all scans in
directories called \code{[Cc]alibration} will be ignored.}

\item{removeMetaData}{\code{logical}, to calculate mass data a lot of
meta data are needed. To save memory they could be deleted after
calculation.}

\item{useHpc}{\code{logical}, should Bruker Daltonics' High Precision
Calibration be used if available? (see also:
\code{\link[readBrukerFlexData]{.hpc}})}

\item{useSpectraNames}{\code{logical}, if \code{TRUE} all list elements
get an unique name from metaData otherwise file path is used.
(If \sQuote{removeMetaData} is \code{TRUE} \sQuote{useSpectraNames}
has no effect.)}

\item{filterZeroIntensities}{\code{logical}, don't change it. If \code{TRUE}
all intensities equal \code{0.0} are removed.
(see also: \code{\link[readBrukerFlexData]{readBrukerFlexFile}})}

\item{verbose}{\code{logical}, print verbose messages?}
}
\value{
A \code{list} of spectra.
\itemize{
    \item{\code{[[1]]$spectrum$mass}: A vector of calculated mass.}
    \item{\code{[[1]]$spectrum$intensity}: A vector of intensity values.}
    \item{\code{[[1]]$metaData}: A list of metaData depending on read spectrum.}
}
}
\description{
This function leads recursively all mass spectrometry data in
Bruker Daltonics XMASS format in a specified directory.
}
\details{
See \code{\link[readBrukerFlexData]{readBrukerFlexFile}}.
}
\examples{
## load library
library("readBrukerFlexData")

## get examples directory
exampleDirectory <- system.file("Examples", package="readBrukerFlexData")

## read example spectra
spec <- readBrukerFlexDir(file.path(exampleDirectory,
  "2010_05_19_Gibb_C8_A1"))

## plot spectra
plot(spec[[1]]$spectrum$mass, spec[[1]]$spectrum$intensity, type="n")

l <- length(spec)
legendStr <- character(l)
for (i in seq(along=spec)) {
  lines(spec[[i]]$spectrum$mass, spec[[i]]$spectrum$intensity, type="l",
        col=rainbow(l)[i])
  legendStr[i] <- spec[[i]]$metaData$fullName
}

## draw legend
legend(x="topright", legend=legendStr, col=rainbow(l), lwd=1)

}
\seealso{
\code{\link[MALDIquantForeign]{importBrukerFlex}},
 \code{\link[readBrukerFlexData]{readBrukerFlexFile}},
 \code{\link[readBrukerFlexData]{.hpc}}
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/double2singlePrecision-functions.R
\name{.changePrecision}
\alias{.changePrecision}
\title{Change precision.}
\usage{
.changePrecision(x, size)
}
\arguments{
\item{x}{\code{double}, a vector of double values which should converted.}

\item{size}{\code{integer}, how many bytes using for target precision
e.g. IEEE 754 single precision: \code{size=4},
IEEE 754 double precision: \code{size=8}}
}
\value{
\code{double}.
}
\description{
This function converts double values to double values in a given
precision (only correctly working for cut a higher precision to a lower one;
e.g.  IEEE 754 double precision to IEEE 754 single precision)
}
\seealso{
\code{\link[readBrukerFlexData]{.double2singlePrecision}},
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readBrukerFlexFile-functions.R
\name{readBrukerFlexFile}
\alias{readBrukerFlexFile}
\title{Reads mass spectrometry data in Bruker Daltonics XMASS format.}
\usage{
readBrukerFlexFile(
  fidFile,
  removeMetaData = FALSE,
  useHpc = TRUE,
  filterZeroIntensities = FALSE,
  keepNegativeIntensities = FALSE,
  verbose = FALSE
)
}
\arguments{
\item{fidFile}{\code{character}, path to \emph{fid} file which should be
read.}

\item{removeMetaData, }{\code{logical}, to calculate mass data a lot of meta
data are needed. To save memory they could be deleted after calculation.}

\item{useHpc}{\code{logical}, should Bruker Daltonics' High Precision
Calibration be used if available?
(see also: \code{\link[readBrukerFlexData]{.hpc}})}

\item{filterZeroIntensities}{\code{logical}, don't change it.
If \code{TRUE} all intensities equal \code{0.0} are removed.
(see also: \sQuote{Details} section)}

\item{keepNegativeIntensities}{\code{logical}, don't change it.
If \code{FALSE} all intensities less than zero are replaced by
zero.
(see also: \sQuote{Details} section)}

\item{verbose}{\code{logical}, print verbose messages?}
}
\value{
A \code{list} of spectra and metadata.

 \itemize{
    \item{\code{spectrum$mass}: A vector of calculated mass.}
    \item{\code{spectrum$tof}: A vector of time-of-flight data.}
    \item{\code{spectrum$intensity}: A vector of intensity values.}
    \item{\code{metaData}: A list of metaData depending on read spectrum.}
}
}
\description{
This function reads mass spectrometry data in Bruker Daltonics XMASS format
used by Bruker Daltonics mass spectrometer of *flex series (autoflex,
microflex, ultraflex).
}
\details{
\code{readBrukerFlexFile} has to import the following data to calculating
mass from \emph{acqu} file:\cr

\tabular{lll}{
acqu-value \tab becomes metaData \tab description \cr
$BYTORDA \tab metaData$byteOrder \tab endianness of fid file \cr
$TD \tab metaData$number \tab total number of measured time periods \cr
$DELAY \tab metaData$timeDelay \tab first measured intensity after
  \emph{metaData$timeDelay} ns \cr
$DW \tab metaData$timeDelta \tab ns between measured time periods \cr
$ML1 \tab metaData$calibrationConstants[1] \tab mass calibration constant \cr
$ML2 \tab metaData$calibrationConstants[2] \tab mass calibration constant \cr
$ML3 \tab metaData$calibrationConstants[3] \tab mass calibration constant \cr
}

If High Precision Calibration (HPC) is used, \code{readBrukerFlexFile} needs:
\tabular{lll}{
acqu-value \tab becomes metaData \tab description \cr
$HPClBHi \tab metaData$hpc$limits[\dQuote{maxMass}] \tab upper mass
 threshold \cr
$HPClBLo \tab metaData$hpc$limits[\dQuote{minMass}] \tab lower mass
 threshold \cr
$HPClOrd \tab metaData$hpc$order \tab polynomial order \cr
$HPClUse \tab metaData$hpc$use \tab maybe using of HPC? (seems to be always
\dQuote{yes} in our test data) \cr
$HPCStr \tab metaData$hpc$coefficients \tab polynomial coefficients in a
string \cr
}

\code{readBrukerFlexFile} tries also to import [optional]: \cr
\tabular{lll}{
acqu-value \tab becomes metaData \tab description \cr
DATATYPE \tab metaData$dataType \tab e.g CONTINUOUS MASS SPECTRUM \cr
SPECTROMETER/DATASYSTEM \tab metaData$dataSystem \tab
 e.g. Bruker Flex Series \cr
.SPECTROMETER TYPE \tab metaData$spectrometerType \tab e.g. TOF \cr
.INLET \tab metaData$inlet \tab DIRECT \cr
.IONIZATION MODE \tab metaData$ionizationMode \tab e.g. LD+ \cr
$DATE \tab metaData$date \tab same as $AQ_DATE but often only "0" \cr
$ACQMETH \tab metaData$acquisitionMethod \tab path to method file \cr
$AQ_DATE \tab metaData$acquisitionDate \tab acquisition date \cr
$AQ_mod \tab metaData$acquisitionMode \tab acquisition mode \cr
$AQOP_m \tab metaData$acquisitionOperatorMode, metaData$tofMode \tab
 LINEAR / REFLECTOR \cr
$ATTEN \tab metaData$laserAttenuation \tab laser beam attenuation \cr
$CMT[1:4] \tab metaData$comments \tab comments \cr
$DEFLON \tab metaData$deflection \tab deflection ON/OFF \cr
$DIGTYP \tab metaData$digitizerType \tab type of digitizer \cr
$DPCAL1 \tab metaData$deflectionPulserCal1 \tab deflection pulser cal 1 \cr
$DPMASS \tab metaData$deflectionPulserMass \tab deflection pulser mass \cr
$FCVer \tab metaData$flexControlVersion \tab Version of
 Bruker Daltonics FlexControl software \cr
$ID_raw \tab metaData$id \tab spectrum id \cr
$INSTRUM \tab metaData$instrument \tab e.g. AUTOFLEX \cr
$InstrID \tab metaData$instrumentId \tab ID of mass spectrometer \cr
$InstTyp \tab metaData$instrumentType \tab instrument type \cr
$Lift1 \tab metaData$lift[1] \tab LIFT constant? \cr
$Lift2 \tab metaData$lift[2] \tab LIFT constant? \cr
$Masserr \tab metaData$massError \tab initial mass error in ppm \cr
$NoSHOTS \tab metaData$laserShots \tab number of applied laser shots \cr
$PATCHNO \tab metaData$patch \tab sample postion on target \cr
$PATH \tab metaData$path \tab original file path
 (on Bruker *flex series controller PC) \cr
$REPHZ \tab metaData$laserRepetition \tab laser repetition rate in Hz \cr
$SPOTNO \tab metaData$spot \tab same as \emph{$PATCHNO}
 (in older files often empty, that's why \code{readBrukerFlexFile}
 uses \emph{$PATHNO} instead) \cr
$SPType \tab metaData$spectrumType \tab e.g. TOF \cr
$TgIDS \tab metaData$target$id \tab target ids \cr
$TgCount \tab metaData$target$count \tab number of measurements
 with this target \cr
$TgSer \tab metaData$target$serialNumber \tab target serial number \cr
$TgTyp \tab metaData$target$typeNumber \tab target type number \cr
$TLift \tab metaData$tlift \tab LIFT constant? \cr
}

import from file path:
\tabular{lll}{
value \tab becomes metaData \tab description \cr
full current path to fid file \tab metaData$file \tab
 path on local machine \cr
sample name \tab metaData$sampleName \tab - \cr
}

\code{filterZeroIntensities}: Change default value is \bold{not recommended}!
If \code{TRUE} all intensities equal zero are removed.
This parameter exists only to be compatible to
Bruker Daltonics CompassXport's mzXML export function. For details see:
\sQuote{Release Notes for CompassXport 3.0.3},
cap. 6 \sQuote{Filtering of Zero Intensities}:
\dQuote{Bruker Daltonics' Acquisition Software will compress Analysis raw
data. To save on operation time and to keep export file sizes small,
CompassXport 3.0.3 will filter out zero (0.0) intensities
when exporting to mzXML or mzData \ldots}

\code{keepNegativeIntensities}: Change default value is
\bold{not recommended}! If \code{TRUE} negative intensity values are not
replaced by zero. This parameter exists only to be compatible to
Bruker Daltonics CompassXport.
}
\examples{
## load library
library("readBrukerFlexData")

## get examples directory
exampleDirectory <- system.file("Examples", package="readBrukerFlexData")

## read example spectrum
spec <- readBrukerFlexFile(file.path(exampleDirectory,
  "2010_05_19_Gibb_C8_A1/0_A1/1/1SLin/fid"))

## print metaData
print(spec$metaData)

## plot spectrum
plot(spec$spectrum$mass, spec$spectrum$intensity, type="l", col="red")

}
\seealso{
\url{https://github.com/sgibb/readBrukerFlexData/wiki},
 \code{\link[MALDIquantForeign]{importBrukerFlex}},
 \code{\link[readBrukerFlexData]{readBrukerFlexDir}},
 \code{\link[readBrukerFlexData]{.hpc}}
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tof2mass-functions.R
\name{.tof2mass}
\alias{.tof2mass}
\title{Calculates mass from time-of-flight values.}
\usage{
.tof2mass(tof, c1, c2, c3)
}
\arguments{
\item{tof}{\code{double}, vector with times-of-flight}

\item{c1}{metaData$calibrationConstants[1]}

\item{c2}{metaData$calibrationConstants[2]}

\item{c3}{metaData$calibrationConstants[3]}
}
\value{
\code{double}, calculated mass
}
\description{
This function calculates mass from time of flight values
based on the following article:
 Titulaer, M. K. and Siccama, I. and Dekker, J. L. and
 van Rijswijk, A. L. and Heeren R. M. and Sillevis Smitt, P. A. and
 Luider, T. M. (2006) \cr
 \dQuote{A database application for pre-processing, storage and comparison
 of mass spectra derived from patients and controls},
 \emph{BMC Bioinformatics}, \bold{7}: 403
 \url{https://pubmed.ncbi.nlm.nih.gov/16953879/}
}
\details{
Arguments are imported from metadata (acqu-file).
}
\references{
Titulaer, M. K. and Siccama, I. and Dekker, J. L. and
 van Rijswijk, A. L. and Heeren R. M. and Sillevis Smitt, P. A. and
 Luider, T. M. (2006) \cr
 \dQuote{A database application for pre-processing, storage and comparison
 of mass spectra derived from patients and controls},
 \emph{BMC Bioinformatics}, \bold{7}: 403
 \url{https://pubmed.ncbi.nlm.nih.gov/16953879/}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ntbcal-functions.R
\name{.ctof2calibration}
\alias{.ctof2calibration}
\title{Cubic calibration}
\usage{
.ctof2calibration(tof, d)
}
\arguments{
\item{tof}{\code{double}, time of flight.}

\item{d}{\code{double}, calibration constants, return value of
\code{.extractV10CTOF2CalibrationConstants}.}
}
\value{
\code{double}, mz values.
}
\description{
Only basic support (not 100\% identical results) for Bruker Daltonics' cubic
calibration (encoded in `"##$NTBCal"` as `"V1.0CTOF2CalibrationConstants"`).
This is an internal function and should normally not used by the user.
}
\note{
Bruker Daltonics doesn't explain how the cubic calibration works.
All formula are results of \dQuote{trial and error}.
That is why mass calculated by \code{.ctof2calibration}
differs little from original mass.
See also \url{https://github.com/sgibb/readBrukerFlexData/issues/3}.
}
\seealso{
\url{https://github.com/sgibb/readBrukerFlexData/issues/3}
}
\author{
Alan Race, Samuel Granjeaud, Sebastian Gibb
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cpSpecHpcMzXml-data.R
\docType{data}
\name{cpSpecHpcMzXml}
\alias{cpSpecHpcMzXml}
\title{Mass spectrum generated by Bruker Daltonics CompassXport}
\format{
A list containing a mass and an intensity vector.
}
\source{
Examples/hpc/mzXML/hpc.mzXML
}
\description{
This dataset was generated by Bruker Daltonics CompassXport and imported by
\code{\link[readMzXmlData]{readMzXmlFile}} to R. It is only needed for
comparison between Bruker Daltonics' HPC and
\code{\link[readBrukerFlexData]{.hpc}}.
}
\seealso{
\code{\link[readBrukerFlexData]{.hpc}},
 \code{\link[readMzXmlData]{readMzXmlFile}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hpc-functions.R
\name{.extractHPCConstants}
\alias{.extractHPCConstants}
\title{Extracts High Precision Calibration coefficients.}
\usage{
.extractHPCConstants(hpcStr)
}
\arguments{
\item{hpcStr}{metaData$hpcStr, which store coefficents
\preformatted{
hpcStr <- "V1.0CHPCData  Order 10 vCoeff V1.0VectorDouble 11
           -0.48579224953906053 0.0009361303203700988
           -6.92711401708155e-008 -1.0992953299897006e-009
           1.1718229914003113e-012 -5.392578762547374e-016
           9.0176664604755316e-020 1.9704001597871883e-023
           -1.1794161284667635e-026 2.0351573912658823e-030
           -1.2617853301428769e-034
           c2 -0.046701600316874939
           c0 237.64781433281422
           minMass 736.50266799999997
           maxMass 3698.6377320000001 bUse 1 endCHPCData"
}}
}
\value{
a \code{list}:
 \itemize{
   \item{\code{hpcConstants$coefficients}: double, vector of coefficents}
   \item{\code{hpcConstants$calibrationConstant0}: c0}
   \item{\code{hpcConstants$calibrationConstant2}: c2}
 }
}
\description{
This is a helper function to extract coefficients and constants from
metaData$hpcStr.
}
\seealso{
\code{\link[readBrukerFlexData]{.hpc}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package.R
\name{readBrukerFlexData-defunct}
\alias{readBrukerFlexData-defunct}
\alias{mqReadBrukerFlex}
\title{Removed functions in package \pkg{readBrukerFlexData}}
\description{
These functions are defunct and no longer available.
}
\details{
\describe{
 \item{mqReadBrukerFlex:}{use
   \code{\link[MALDIquantForeign]{importBrukerFlex}} instead.}
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/double2singlePrecision-functions.R
\name{.double2singlePrecision}
\alias{.double2singlePrecision}
\title{Converts double to single precision.}
\usage{
.double2singlePrecision(x)
}
\arguments{
\item{x}{\code{double}, numeric value which should reduce from double
precision to single precision.}
}
\value{
\code{double} (in single precision).
}
\description{
This function simulates the conversion of floating point numbers from double
precision (64bit, R: \code{double()}, C: \code{double}) to single precision
(32bit, R: \code{none}, C: \code{float}). It follows IEEE 754 standard.
}
\details{
The same could be done in C by using casts:
\preformatted{
double precision32(double value) {
  float x=value;
  return (double)x;
}}
}
\examples{
## load library
library("readBrukerFlexData")

## show more details
oldDigits <- options()$digits
options(digits=22)

## a test number
num <- 1/3

num
readBrukerFlexData:::.double2singlePrecision(num)

## reset digits option
options(digits=oldDigits)

}
\references{
IEEE 754 standard: \url{https://ieeexplore.ieee.org/xpl/articleDetails.jsp?arnumber=30711&filter=AND(p_Publication_Number:2355)}
}
\seealso{
\code{\link[readBrukerFlexData]{.changePrecision}},
 \code{\link[readBrukerFlexData]{.hpc}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grepAcquValue-functions.R
\name{.grepAcquDoubleValue}
\alias{.grepAcquDoubleValue}
\title{Extracts values from acqu file.}
\usage{
.grepAcquDoubleValue(patternStr, srcStr)
}
\arguments{
\item{patternStr}{\code{character}, pattern to look for}

\item{srcStr}{\code{character} where to look for \code{patternStr}}
}
\value{
\code{double} vector of the value given in \code{patternStr}
}
\description{
This function is a helper function to extract double values from acqu file.
}
\seealso{
\code{\link[readBrukerFlexData]{.grepAcquValue}},
 \code{\link[readBrukerFlexData]{.readAcquFile}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package.R
\docType{package}
\name{readBrukerFlexData-package}
\alias{readBrukerFlexData}
\alias{readBrukerFlexData-package}
\title{The readBrukerFlexData Package}
\description{
The readBrukerFlexData package reads data files acquired by MALDI-TOF MS on
Bruker Daltonics machines of the *flex series. (autoflex,
microflex, ultraflex). \cr
The package was developed \emph{without} any knowledge nor even support by
Bruker Daltonics.
\cr \cr
All trademarks are owned by or licensed to Bruker Daltonics.
}
\references{
\url{https://github.com/sgibb/readBrukerFlexData}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://strimmerlab.github.io/software/maldiquant/}
  \item \url{https://github.com/sgibb/readBrukerFlexData/}
  \item Report bugs at \url{https://github.com/sgibb/readBrukerFlexData/issues/}
}

}
\author{
Sebastian Gibb \email{mail@sebastiangibb.de}
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sampleName-functions.R
\name{.sampleName}
\alias{.sampleName}
\title{Creates sample name.}
\usage{
.sampleName(fidFile)
}
\arguments{
\item{fidFile}{\code{character}, path to fid file
(e.g. \sQuote{Pankreas_HB_L_061019_A10/0_a19/1/1SLin/fid})}
}
\value{
\code{character}, sample name: e.g \sQuote{Pankreas_HB_L_061019_A10}
}
\description{
This function guesses the name of current spot from filename.
}
\note{
WARNING: if the 4th upper directory hasn't an unique name you will get
 equal names for your spot list

 e.g. the following will create a list with 4 elements but
 only 2 unique spot names (2-100kDa:0_A1 and 2-100kDa:0_B1) \cr
./Run1/2-100kDa/0_A1/1/1SLin/fid \cr
./Run1/2-100kDa/0_B1/1/1SLin/fid \cr
./Run2/2-100kDa/0_A1/1/1SLin/fid \cr
./Run2/2-100kDa/0_B1/1/1SLin/fid \cr
}
\seealso{
\code{\link[readBrukerFlexData]{.readAcquFile}},
 \code{\link[readBrukerFlexData]{readBrukerFlexFile}}
}
\keyword{internal}
